NNN(1)

NAME
nnn - the missing terminal file manager for X

SYNOPSIS
nnn [-b key] [-c N] [-e] [-i] [-l] [-S] [-v] [-h] [PATH]

DESCRIPTION
nnn (Noice is Not Noice) is a performance-optimized, feature-packed fork of noice (http://git.2f30.org/noice/) with seamless desktop integration, simplified navigation, navigate-as-you-type mode, disk usage analyzer mode, bookmarks, contexts, application launcher, familiar navigation shortcuts, subshell spawning and much more. It remains a simple and efficient file manager that stays out of your way.

nnn opens the current working directory by default if PATH is not specified.

KEYBINDS

nnn supports both vi-like and emacs-like key bindings as listed below.

NAVIGATION

[Up], k, ^P
    Move to previous entry
[Down], j, ^N
    Move to next entry
[PgUp], ^U
    Scroll up half a page
[PgDn], ^D
    Scroll down half a page
[Home], g, ^, ^A
    Move to the first entry
[End], G, $, ^E
    Move to the last entry
[Left], [Backspace], h, ^H
    Go to parent directory
[Right], [Enter], l, ^M
    Open file or enter directory
~   Change to the HOME directory
&   Change to initial directory
-   Change to the last visited directory
.   Toggle show hidden . (dot) files
/   Change filter (more information below)
[Insert], ^I
    Toggle navigate-as-you-type mode
b   Pin current directory
^W  Visit pinned directory
`, ^/
    Leader key
LeaderN
    Switch to context N
Esc Exit prompt
^L  Force a redraw, clear prompt
q   Quit the current context
^G  Quit and change directory
Q, ^Q
    Quit
?   Help and configuration screen

FILES

^O  Open with an application
n   Create a new file or directory
D   Show entry details
d   Toggle detail view
^R  Rename selected entry
r   Open directory in vidir
Y, ^Y
    Toggle selection mode
Space, ^K
    Copy entry absolute path
y   Show selection list
^T  Toggle path quote
P   Copy files from selection
V   Move files from selection
X   Delete files from selection
^X  Delete entry
f   Archive entry
F   List files in archive
^F  Extract archive in current directory
m, M
    Show brief/full media info
e   Open entry in EDITOR (fallback vi)
p   Open entry in PAGER (fallback less)

ORDER

^J  Toggle disk usage analyzer mode
S   Toggle sort by apparent size
s   Toggle sort by file size
t   Toggle sort by time modified

MISC

o   Launch a GUI application
!, ^]
    Spawn SHELL in current directory (fallback sh)
R   Run a custom script
L   Lock terminal (Linux only)

Backing up one directory level will set the cursor position at the directory you came out of.

Help & settings, file details, media info and archive listing are shown in the PAGER. Please use the PAGER-specific keys in these screens.

OPTIONS

nnn supports the following options:

-b key specify bookmark key to open

-c N specify dir color (default blue), disables if N>7 0-black, 1-red, 2-green, 3-yellow, 4-blue, 5-magenta, 6-cyan, 7-white

-e use exiftool instead of mediainfo

-i start in navigate-as-you-type mode

-l start in light mode (fewer details)

-S start in disk usage analyzer mode

-v show version and exit

-h show program help and exit

CONFIGURATION
nnn uses xdg-open (on Linux) and open(1) (on OS X) as the desktop opener.

There is no configuration file. Settings work on environment variables. Please refer to the ENVIRONMENT section below.

Configuring nnn to change to the last visited directory on quit requires shell integration in a few easy steps. Please visit the project page (linked below) for the instructions.

CONTEXTS
Contexts serve the purpose of exploring multiple directories simultaneously. 4 contexts are available. The status of the contexts are shown in the top left corner:

- the current context is in reverse
- other used contexts are underlined
- rest are unused

To switch to a context press the Leader key followed by the context number (1-4).

The first time a context is entered, it copies the state of the last visited context. Each context remembers its start directory and last visited directory.

When a context is quit, the next active context is selected. If the last active context is quit, the program quits.

FILTERS
Filters support regexes to instantly (search-as-you-type) list the matching entries in the current directory.

Ways to exit filter prompt:

(1) press ^L to clear filter followed by Bksp (to clear the filter symbol, like vi)
- at other prompts ^L followed by Enter discards all changes and exits prompt
(2) run a search with no matches and press Enter

Common use cases:

(1) To list all matches starting with the filter expression, start the expression with a '^' (caret) symbol.
(2) Type '\.mkv' to list all MKV files.
(3) Use '.*' to match any character (sort of fuzzy search).

If nnn is invoked as root or the environment variable NNN_SHOW_HIDDEN is set the default filter will also match hidden files.

In the navigate-as-you-type mode directories are opened in filter mode, allowing continuous navigation. Works best with the arrow keys.
In case of only one match and it's a directory, `nnn` auto selects the directory and enters it in this mode.

SELECTION MODE
The absolute path of a single file can be copied to clipboard by pressing ^K if NNN_COPIER is set (see ENVIRONMENT section below).

To copy multiple file paths the selection mode should be enabled using ^Y. In this mode it's possible to

(1) cherry-pick individual files one by one by pressing <kbd>^K</kbd> on each entry; or,
(2) navigate to another file in the same directory to select a range of files.

Pressing ^Y again copies the paths and exits the selection mode. The files in the list can now be copied, moved or removed using respective keyboard shortcuts.

To list the file paths copied to memory press y.

ENVIRONMENT
The SHELL, EDITOR (VISUAL, if defined) and PAGER environment variables take precedence when dealing with the !, e and p commands respectively.

NNN_BMS: bookmark string as key_char:location pairs (max 10) separated by ;:

        export NNN_BMS='d:~/Documents;u:/home/user/Cam Uploads;D:~/Downloads/'
        NOTE: Bookmark keys should be single-character to use them in combination with the Leader key.

NNN_USE_EDITOR: use EDITOR (preferably CLI, fallback vi) to handle text files.

        export NNN_USE_EDITOR=1

NNN_IDLE_TIMEOUT: set idle timeout (in seconds) to invoke terminal locker.

NNN_COPIER: set to a clipboard copier script. For example, on Linux:

        -------------------------------------
        #!/bin/sh
        # comment the next line to convert newlines to spaces
        IFS=
        echo -n $1 | xsel --clipboard --input
        -------------------------------------
        If it's not set, by default file paths are copied to the tmp file DIR/.nnncp, where 'DIR' (by priority) is: $HOME or, $TMPDIR or, /tmp.

NNN_QUOTE_ON: wrap copied paths within single quotes. Useful for pasting names in the shell. Note that the filename is not escaped. So copying may still fail for filenames having quote(s) in them.

NNN_SCRIPT: path to a custom script to invoke with currently selected file name as argument 1.

        export NNN_SCRIPT=/usr/local/bin/nscript

NNN_MULTISCRIPT: run multiple custom scripts.

        export NNN_MULTISCRIPT=1

NNN_SHOW_HIDDEN: show hidden files.

        export NNN_SHOW_HIDDEN=1

NNN_NO_AUTOSELECT: Disable directory auto-selection in navigate-as-you-type mode.

        export NNN_NO_AUTOSELECT=1

KNOWN ISSUES
If you are using urxvt you might have to set backspace key to DEC.

AUTHORS
Lazaros Koromilas <lostd@2f30.org>, Dimitris Papastamos <sin@2f30.org>, Arun Prakash Jana <engineerarun@gmail.com>.

HOME
https://github.com/jarun/nnn